Package org.optaplanner.core.config.score.director

## Class ScoreDirectorFactoryConfig

- java.lang.Object
- - org.optaplanner.core.config.AbstractConfig<ScoreDirectorFactoryConfig>
  - - org.optaplanner.core.config.score.director.ScoreDirectorFactoryConfig

-     public class ScoreDirectorFactoryConfig
      extends AbstractConfig<ScoreDirectorFactoryConfig>

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected ScoreDirectorFactoryConfig` | `assertionScoreDirectorFactory` |
    `protected Integer` | `bendableHardLevelsSize` | Deprecated.
    `protected Integer` | `bendableSoftLevelsSize` | Deprecated.
    `protected Class<? extends ConstraintProvider>` | `constraintProviderClass` |
    `protected Map<String,​String>` | `constraintProviderCustomProperties` |
    `protected ConstraintStreamImplType` | `constraintStreamImplType` |
    `protected Class<? extends EasyScoreCalculator>` | `easyScoreCalculatorClass` |
    `protected Map<String,​String>` | `easyScoreCalculatorCustomProperties` |
    `protected Boolean` | `generateDroolsTestOnError` | Deprecated. for removal.
    `protected Class<? extends IncrementalScoreCalculator>` | `incrementalScoreCalculatorClass` |
    `protected Map<String,​String>` | `incrementalScoreCalculatorCustomProperties` |
    `protected String` | `initializingScoreTrend` |
    `protected org.kie.api.KieBase` | `kieBase` | Deprecated.
    `protected Map<String,​String>` | `kieBaseConfigurationProperties` |
    `protected String` | `ksessionName` |
    `protected Class<? extends ScoreDefinition>` | `scoreDefinitionClass` | Deprecated.
    `protected ScoreDefinitionType` | `scoreDefinitionType` | Deprecated.
    `protected List<File>` | `scoreDrlFileList` |
    `protected List<String>` | `scoreDrlList` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ScoreDirectorFactoryConfig()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected <Solution_> ConstraintStreamScoreDirectorFactory<Solution_>` | `buildConstraintStreamScoreDirectorFactory​(SolutionDescriptor<Solution_> solutionDescriptor)` |
    `ScoreDefinition` | `buildDeprecatedScoreDefinition()` |
    `protected <Solution_> DroolsScoreDirectorFactory<Solution_>` | `buildDroolsScoreDirectorFactory​(SolverConfigContext configContext, ClassLoader classLoader, SolutionDescriptor<Solution_> solutionDescriptor)` |
    `protected <Solution_> EasyScoreDirectorFactory<Solution_>` | `buildEasyScoreDirectorFactory​(SolutionDescriptor<Solution_> solutionDescriptor)` |
    `protected <Solution_> IncrementalScoreDirectorFactory<Solution_>` | `buildIncrementalScoreDirectorFactory​(SolutionDescriptor<Solution_> solutionDescriptor)` |
    `<Solution_> InnerScoreDirectorFactory<Solution_>` | `buildScoreDirectorFactory​(SolverConfigContext configContext, ClassLoader classLoader, EnvironmentMode environmentMode, SolutionDescriptor<Solution_> solutionDescriptor)` |
    `ScoreDirectorFactoryConfig` | `copyConfig()` | Typically implemented by constructing a new instance and calling `AbstractConfig.inherit(AbstractConfig)` on it
    `ScoreDirectorFactoryConfig` | `getAssertionScoreDirectorFactory()` |
    `Integer` | `getBendableHardLevelsSize()` | Deprecated. Use `PlanningScore.bendableHardLevelsSize()` instead.
    `Integer` | `getBendableSoftLevelsSize()` | Deprecated. Use `PlanningScore.bendableSoftLevelsSize()` instead.
    `Class<? extends ConstraintProvider>` | `getConstraintProviderClass()` |
    `Map<String,​String>` | `getConstraintProviderCustomProperties()` |
    `ConstraintStreamImplType` | `getConstraintStreamImplType()` |
    `Class<? extends EasyScoreCalculator>` | `getEasyScoreCalculatorClass()` |
    `Map<String,​String>` | `getEasyScoreCalculatorCustomProperties()` |
    `Class<? extends IncrementalScoreCalculator>` | `getIncrementalScoreCalculatorClass()` |
    `Map<String,​String>` | `getIncrementalScoreCalculatorCustomProperties()` |
    `String` | `getInitializingScoreTrend()` |
    `org.kie.api.KieBase` | `getKieBase()` | Deprecated. Use `setKsessionName(String)` and `SolverFactory.createFromKieContainerXmlResource(KieContainer, String)` instead.
    `Map<String,​String>` | `getKieBaseConfigurationProperties()` |
    `String` | `getKsessionName()` |
    `Class<? extends ScoreDefinition>` | `getScoreDefinitionClass()` | Deprecated. Use `PlanningScore.scoreDefinitionClass()` instead.
    `ScoreDefinitionType` | `getScoreDefinitionType()` | Deprecated. Use `PlanningScore` instead.
    `List<File>` | `getScoreDrlFileList()` |
    `List<String>` | `getScoreDrlList()` |
    `ScoreDirectorFactoryConfig` | `inherit​(ScoreDirectorFactoryConfig inheritedConfig)` | Inherits each property of the `inheritedConfig` unless that property (or a semantic alternative) is defined by this instance (which overwrites the inherited behaviour).
    `Boolean` | `isGenerateDroolsTestOnError()` | Deprecated. for removal.
    `void` | `setAssertionScoreDirectorFactory​(ScoreDirectorFactoryConfig assertionScoreDirectorFactory)` |
    `void` | `setBendableHardLevelsSize​(Integer bendableHardLevelsSize)` | Deprecated. Use `PlanningScore.bendableHardLevelsSize()` instead.
    `void` | `setBendableSoftLevelsSize​(Integer bendableSoftLevelsSize)` | Deprecated. Use `PlanningScore.bendableSoftLevelsSize()` instead.
    `void` | `setConstraintProviderClass​(Class<? extends ConstraintProvider> constraintProviderClass)` |
    `void` | `setConstraintProviderCustomProperties​(Map<String,​String> constraintProviderCustomProperties)` |
    `void` | `setConstraintStreamImplType​(ConstraintStreamImplType constraintStreamImplType)` |
    `void` | `setEasyScoreCalculatorClass​(Class<? extends EasyScoreCalculator> easyScoreCalculatorClass)` |
    `void` | `setEasyScoreCalculatorCustomProperties​(Map<String,​String> easyScoreCalculatorCustomProperties)` |
    `void` | `setGenerateDroolsTestOnError​(Boolean generateDroolsTestOnError)` | Deprecated. for removal.
    `void` | `setIncrementalScoreCalculatorClass​(Class<? extends IncrementalScoreCalculator> incrementalScoreCalculatorClass)` |
    `void` | `setIncrementalScoreCalculatorCustomProperties​(Map<String,​String> incrementalScoreCalculatorCustomProperties)` |
    `void` | `setInitializingScoreTrend​(String initializingScoreTrend)` |
    `void` | `setKieBase​(org.kie.api.KieBase kieBase)` | Deprecated. Use `setKsessionName(String)` and `SolverFactory.createFromKieContainerXmlResource(KieContainer, String)` instead.
    `void` | `setKieBaseConfigurationProperties​(Map<String,​String> kieBaseConfigurationProperties)` |
    `void` | `setKsessionName​(String ksessionName)` |
    `void` | `setScoreDefinitionClass​(Class<? extends ScoreDefinition> scoreDefinitionClass)` | Deprecated. Use `PlanningScore.scoreDefinitionClass()` instead.
    `void` | `setScoreDefinitionType​(ScoreDefinitionType scoreDefinitionType)` | Deprecated. Use `PlanningScore` instead.
    `void` | `setScoreDrlFileList​(List<File> scoreDrlFileList)` |
    `void` | `setScoreDrlList​(List<String> scoreDrlList)` |
    `ScoreDirectorFactoryConfig` | `withAssertionScoreDirectorFactory​(ScoreDirectorFactoryConfig assertionScoreDirectorFactory)` |
    `ScoreDirectorFactoryConfig` | `withConstraintProviderClass​(Class<? extends ConstraintProvider> constraintProviderClass)` |
    `ScoreDirectorFactoryConfig` | `withConstraintProviderCustomProperties​(Map<String,​String> constraintProviderCustomProperties)` |
    `ScoreDirectorFactoryConfig` | `withConstraintStreamImplType​(ConstraintStreamImplType constraintStreamImplType)` |
    `ScoreDirectorFactoryConfig` | `withEasyScoreCalculatorClass​(Class<? extends EasyScoreCalculator> easyScoreCalculatorClass)` |
    `ScoreDirectorFactoryConfig` | `withEasyScoreCalculatorCustomProperties​(Map<String,​String> easyScoreCalculatorCustomProperties)` |
    `ScoreDirectorFactoryConfig` | `withIncrementalScoreCalculatorClass​(Class<? extends IncrementalScoreCalculator> incrementalScoreCalculatorClass)` |
    `ScoreDirectorFactoryConfig` | `withIncrementalScoreCalculatorCustomProperties​(Map<String,​String> incrementalScoreCalculatorCustomProperties)` |
    `ScoreDirectorFactoryConfig` | `withInitializingScoreTrend​(String initializingScoreTrend)` |
    `ScoreDirectorFactoryConfig` | `withScoreDrlFileList​(List<File> scoreDrlFileList)` |
    `ScoreDirectorFactoryConfig` | `withScoreDrlFiles​(File... scoreDrlFiles)` |
    `ScoreDirectorFactoryConfig` | `withScoreDrlList​(List<String> scoreDrlList)` |
    `ScoreDirectorFactoryConfig` | `withScoreDrls​(String... scoreDrls)` |

    - ### Methods inherited from class org.optaplanner.core.config.AbstractConfig

      `deduceEntityDescriptor, deduceVariableDescriptor, deduceVariableDescriptorList, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### scoreDefinitionClass

          @Deprecated
          protected Class<? extends ScoreDefinition> scoreDefinitionClass

      Deprecated.

    - #### scoreDefinitionType

          @Deprecated
          protected ScoreDefinitionType scoreDefinitionType

      Deprecated.

    - #### bendableHardLevelsSize

          @Deprecated
          protected Integer bendableHardLevelsSize

      Deprecated.

    - #### bendableSoftLevelsSize

          @Deprecated
          protected Integer bendableSoftLevelsSize

      Deprecated.

    - #### easyScoreCalculatorClass

          protected Class<? extends EasyScoreCalculator> easyScoreCalculatorClass

    - #### easyScoreCalculatorCustomProperties

          @XStreamConverter(KeyAsElementMapConverter.class)
          protected Map<String,​String> easyScoreCalculatorCustomProperties

    - #### constraintProviderClass

          protected Class<? extends ConstraintProvider> constraintProviderClass

    - #### constraintProviderCustomProperties

          @XStreamConverter(KeyAsElementMapConverter.class)
          protected Map<String,​String> constraintProviderCustomProperties

    - #### constraintStreamImplType

          protected ConstraintStreamImplType constraintStreamImplType

    - #### incrementalScoreCalculatorClass

          protected Class<? extends IncrementalScoreCalculator> incrementalScoreCalculatorClass

    - #### incrementalScoreCalculatorCustomProperties

          @XStreamConverter(KeyAsElementMapConverter.class)
          protected Map<String,​String> incrementalScoreCalculatorCustomProperties

    - #### ksessionName

          protected String ksessionName

    - #### kieBase

          @Deprecated
          protected org.kie.api.KieBase kieBase

      Deprecated.

    - #### scoreDrlList

          protected List<String> scoreDrlList

    - #### scoreDrlFileList

          protected List<File> scoreDrlFileList

    - #### kieBaseConfigurationProperties

          @XStreamConverter(KeyAsElementMapConverter.class)
          protected Map<String,​String> kieBaseConfigurationProperties

    - #### generateDroolsTestOnError

          @Deprecated
          protected Boolean generateDroolsTestOnError

      Deprecated.
      for removal.

    - #### initializingScoreTrend

          protected String initializingScoreTrend

    - #### assertionScoreDirectorFactory

          protected ScoreDirectorFactoryConfig assertionScoreDirectorFactory

  - ### Constructor Detail

    - #### ScoreDirectorFactoryConfig

          public ScoreDirectorFactoryConfig()

  - ### Method Detail

    - #### getScoreDefinitionClass

          @Deprecated
          public Class<? extends ScoreDefinition> getScoreDefinitionClass()

      Deprecated.
      Use `PlanningScore.scoreDefinitionClass()` instead. Will be removed in 8.0.
      Returns:
        sometimes null

    - #### setScoreDefinitionClass

          @Deprecated
          public void setScoreDefinitionClass​(Class<? extends ScoreDefinition> scoreDefinitionClass)

      Deprecated.
      Use `PlanningScore.scoreDefinitionClass()` instead. Will be removed in 8.0.
      Parameters:
        `scoreDefinitionClass` - sometimes null

    - #### getScoreDefinitionType

          @Deprecated
          public ScoreDefinitionType getScoreDefinitionType()

      Deprecated.
      Use `PlanningScore` instead. Will be removed in 8.0.
      Returns:
        sometimes null

    - #### setScoreDefinitionType

          @Deprecated
          public void setScoreDefinitionType​(ScoreDefinitionType scoreDefinitionType)

      Deprecated.
      Use `PlanningScore` instead. Will be removed in 8.0.
      Parameters:
        `scoreDefinitionType` - sometimes null

    - #### getBendableHardLevelsSize

          @Deprecated
          public Integer getBendableHardLevelsSize()

      Deprecated.
      Use `PlanningScore.bendableHardLevelsSize()` instead. Will be removed in 8.0.
      Returns:
        sometimes null

    - #### setBendableHardLevelsSize

          @Deprecated
          public void setBendableHardLevelsSize​(Integer bendableHardLevelsSize)

      Deprecated.
      Use `PlanningScore.bendableHardLevelsSize()` instead. Will be removed in 8.0.
      Parameters:
        `bendableHardLevelsSize` - sometimes null

    - #### getBendableSoftLevelsSize

          @Deprecated
          public Integer getBendableSoftLevelsSize()

      Deprecated.
      Use `PlanningScore.bendableSoftLevelsSize()` instead. Will be removed in 8.0.
      Returns:
        sometimes null

    - #### setBendableSoftLevelsSize

          @Deprecated
          public void setBendableSoftLevelsSize​(Integer bendableSoftLevelsSize)

      Deprecated.
      Use `PlanningScore.bendableSoftLevelsSize()` instead. Will be removed in 8.0.
      Parameters:
        `bendableSoftLevelsSize` - sometimes null

    - #### getEasyScoreCalculatorClass

          public Class<? extends EasyScoreCalculator> getEasyScoreCalculatorClass()

    - #### setEasyScoreCalculatorClass

          public void setEasyScoreCalculatorClass​(Class<? extends EasyScoreCalculator> easyScoreCalculatorClass)

    - #### getEasyScoreCalculatorCustomProperties

          public Map<String,​String> getEasyScoreCalculatorCustomProperties()

    - #### setEasyScoreCalculatorCustomProperties

          public void setEasyScoreCalculatorCustomProperties​(Map<String,​String> easyScoreCalculatorCustomProperties)

    - #### getConstraintProviderClass

          public Class<? extends ConstraintProvider> getConstraintProviderClass()

    - #### setConstraintProviderClass

          public void setConstraintProviderClass​(Class<? extends ConstraintProvider> constraintProviderClass)

    - #### getConstraintProviderCustomProperties

          public Map<String,​String> getConstraintProviderCustomProperties()

    - #### setConstraintProviderCustomProperties

          public void setConstraintProviderCustomProperties​(Map<String,​String> constraintProviderCustomProperties)

    - #### getConstraintStreamImplType

          public ConstraintStreamImplType getConstraintStreamImplType()

    - #### setConstraintStreamImplType

          public void setConstraintStreamImplType​(ConstraintStreamImplType constraintStreamImplType)

    - #### getIncrementalScoreCalculatorClass

          public Class<? extends IncrementalScoreCalculator> getIncrementalScoreCalculatorClass()

    - #### setIncrementalScoreCalculatorClass

          public void setIncrementalScoreCalculatorClass​(Class<? extends IncrementalScoreCalculator> incrementalScoreCalculatorClass)

    - #### getIncrementalScoreCalculatorCustomProperties

          public Map<String,​String> getIncrementalScoreCalculatorCustomProperties()

    - #### setIncrementalScoreCalculatorCustomProperties

          public void setIncrementalScoreCalculatorCustomProperties​(Map<String,​String> incrementalScoreCalculatorCustomProperties)

    - #### getKsessionName

          public String getKsessionName()

    - #### setKsessionName

          public void setKsessionName​(String ksessionName)

    - #### getKieBase

          @Deprecated
          public org.kie.api.KieBase getKieBase()

      Deprecated.
      Use `setKsessionName(String)` and `SolverFactory.createFromKieContainerXmlResource(KieContainer, String)` instead. Might be removed in 8.0.
      Returns:
        sometimes null

    - #### setKieBase

          @Deprecated
          public void setKieBase​(org.kie.api.KieBase kieBase)

      Deprecated.
      Use `setKsessionName(String)` and `SolverFactory.createFromKieContainerXmlResource(KieContainer, String)` instead. Might be removed in 8.0.
      Parameters:
        `kieBase` - sometimes null

    - #### getScoreDrlList

          public List<String> getScoreDrlList()

    - #### setScoreDrlList

          public void setScoreDrlList​(List<String> scoreDrlList)

    - #### getScoreDrlFileList

          public List<File> getScoreDrlFileList()

    - #### setScoreDrlFileList

          public void setScoreDrlFileList​(List<File> scoreDrlFileList)

    - #### getKieBaseConfigurationProperties

          public Map<String,​String> getKieBaseConfigurationProperties()

    - #### setKieBaseConfigurationProperties

          public void setKieBaseConfigurationProperties​(Map<String,​String> kieBaseConfigurationProperties)

    - #### getInitializingScoreTrend

          public String getInitializingScoreTrend()

    - #### setInitializingScoreTrend

          public void setInitializingScoreTrend​(String initializingScoreTrend)

    - #### getAssertionScoreDirectorFactory

          public ScoreDirectorFactoryConfig getAssertionScoreDirectorFactory()

    - #### setAssertionScoreDirectorFactory

          public void setAssertionScoreDirectorFactory​(ScoreDirectorFactoryConfig assertionScoreDirectorFactory)

    - #### isGenerateDroolsTestOnError

          @Deprecated
          public Boolean isGenerateDroolsTestOnError()

      Deprecated.
      for removal.

    - #### setGenerateDroolsTestOnError

          @Deprecated
          public void setGenerateDroolsTestOnError​(Boolean generateDroolsTestOnError)

      Deprecated.
      for removal.

    - #### withEasyScoreCalculatorClass

          public ScoreDirectorFactoryConfig withEasyScoreCalculatorClass​(Class<? extends EasyScoreCalculator> easyScoreCalculatorClass)

    - #### withEasyScoreCalculatorCustomProperties

          public ScoreDirectorFactoryConfig withEasyScoreCalculatorCustomProperties​(Map<String,​String> easyScoreCalculatorCustomProperties)

    - #### withConstraintProviderClass

          public ScoreDirectorFactoryConfig withConstraintProviderClass​(Class<? extends ConstraintProvider> constraintProviderClass)

    - #### withConstraintProviderCustomProperties

          public ScoreDirectorFactoryConfig withConstraintProviderCustomProperties​(Map<String,​String> constraintProviderCustomProperties)

    - #### withConstraintStreamImplType

          public ScoreDirectorFactoryConfig withConstraintStreamImplType​(ConstraintStreamImplType constraintStreamImplType)

    - #### withIncrementalScoreCalculatorClass

          public ScoreDirectorFactoryConfig withIncrementalScoreCalculatorClass​(Class<? extends IncrementalScoreCalculator> incrementalScoreCalculatorClass)

    - #### withIncrementalScoreCalculatorCustomProperties

          public ScoreDirectorFactoryConfig withIncrementalScoreCalculatorCustomProperties​(Map<String,​String> incrementalScoreCalculatorCustomProperties)

    - #### withScoreDrlList

          public ScoreDirectorFactoryConfig withScoreDrlList​(List<String> scoreDrlList)

    - #### withScoreDrls

          public ScoreDirectorFactoryConfig withScoreDrls​(String... scoreDrls)

    - #### withScoreDrlFileList

          public ScoreDirectorFactoryConfig withScoreDrlFileList​(List<File> scoreDrlFileList)

    - #### withScoreDrlFiles

          public ScoreDirectorFactoryConfig withScoreDrlFiles​(File... scoreDrlFiles)

    - #### withInitializingScoreTrend

          public ScoreDirectorFactoryConfig withInitializingScoreTrend​(String initializingScoreTrend)

    - #### withAssertionScoreDirectorFactory

          public ScoreDirectorFactoryConfig withAssertionScoreDirectorFactory​(ScoreDirectorFactoryConfig assertionScoreDirectorFactory)

    - #### buildDeprecatedScoreDefinition

          public ScoreDefinition buildDeprecatedScoreDefinition()

    - #### buildScoreDirectorFactory

          public <Solution_> InnerScoreDirectorFactory<Solution_> buildScoreDirectorFactory​(SolverConfigContext configContext,
                                                                                            ClassLoader classLoader,
                                                                                            EnvironmentMode environmentMode,
                                                                                            SolutionDescriptor<Solution_> solutionDescriptor)

    - #### buildEasyScoreDirectorFactory

          protected <Solution_> EasyScoreDirectorFactory<Solution_> buildEasyScoreDirectorFactory​(SolutionDescriptor<Solution_> solutionDescriptor)

    - #### buildConstraintStreamScoreDirectorFactory

          protected <Solution_> ConstraintStreamScoreDirectorFactory<Solution_> buildConstraintStreamScoreDirectorFactory​(SolutionDescriptor<Solution_> solutionDescriptor)

    - #### buildIncrementalScoreDirectorFactory

          protected <Solution_> IncrementalScoreDirectorFactory<Solution_> buildIncrementalScoreDirectorFactory​(SolutionDescriptor<Solution_> solutionDescriptor)

    - #### buildDroolsScoreDirectorFactory

          protected <Solution_> DroolsScoreDirectorFactory<Solution_> buildDroolsScoreDirectorFactory​(SolverConfigContext configContext,
                                                                                                      ClassLoader classLoader,
                                                                                                      SolutionDescriptor<Solution_> solutionDescriptor)

    - #### inherit

          public ScoreDirectorFactoryConfig inherit​(ScoreDirectorFactoryConfig inheritedConfig)

      Description copied from class: `AbstractConfig`
      Inherits each property of the `inheritedConfig` unless that property (or a semantic alternative) is defined by this instance (which overwrites the inherited behaviour).

      After the inheritance, if a property on this `AbstractConfig` composition is replaced, it should not affect the inherited composition instance.

      Specified by:
        `inherit` in class `AbstractConfig<ScoreDirectorFactoryConfig>`
      Parameters:
        `inheritedConfig` - never null
      Returns:
        this

    - #### copyConfig

          public ScoreDirectorFactoryConfig copyConfig()

      Description copied from class: `AbstractConfig`
      Typically implemented by constructing a new instance and calling `AbstractConfig.inherit(AbstractConfig)` on it
      Specified by:
        `copyConfig` in class `AbstractConfig<ScoreDirectorFactoryConfig>`
      Returns:
        new instance